'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

require('../css/md.css');

require('../css/display.css');

require('../css/default.css');

var _marked = require('marked');

var _marked2 = _interopRequireDefault(_marked);

var _highlight = require('../lib/highlight');

var _highlight2 = _interopRequireDefault(_highlight);

var _markedExtention = require('../lib/markedExtention');

var _markedExtention2 = _interopRequireDefault(_markedExtention);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var getViewPortHeight = Symbol();
var canUseTag = /<\/?style>/;
(0, _markedExtention2.default)(_marked2.default);

_marked2.default.setOptions({
    // xhtml: true,
    sanitize: true,
    sanitizer: function sanitizer(tag) {
        if (!tag.match(canUseTag)) {
            return tag.replace(/<(\/?.+)>/, '&lt;$1&gt;');
        } else {
            return tag;
        }
    }
});

var MarkDown = function (_React$Component) {
    _inherits(MarkDown, _React$Component);

    function MarkDown(props) {
        _classCallCheck(this, MarkDown);

        var _this = _possibleConstructorReturn(this, (MarkDown.__proto__ || Object.getPrototypeOf(MarkDown)).call(this, props));

        _this.state = {
            displayContent: '',
            leftClassName: 'left',
            rightClassName: 'right',
            printBtnDisplay: 'none',
            saveBtnDisplay: 'block'
        };

        _this.viewPortHeight = _this[getViewPortHeight]();
        _this.initPrint();
        _this.initMarker();
        return _this;
    }

    _createClass(MarkDown, [{
        key: getViewPortHeight,
        value: function value() {
            if (document.compatMode == "BackCompat") {
                return document.body.clientHeight;
            } else {
                return document.documentElement.clientHeight;
            }
        }
    }, {
        key: 'initMarker',
        value: function initMarker() {
            this.markedRenderer = new _marked2.default.Renderer();
            this.markedRenderer.code = function (code, lang) {
                return '<pre><code class="lang-' + lang + ' hljs">' + _highlight2.default.highlightAuto(code).value + '</code></pre>';
            };

            this.markedRenderer.link = function (href, title, text) {
                return '<a href="' + href + '" title="' + title + '" target="_blank" >' + text + '</a>';
            };
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (this.props.onlyRead !== true) this.refs.textInput.focus();

            this.setState({
                displayContent: (0, _marked2.default)(this.props.text, { renderer: this.markedRenderer })
            });
        }
    }, {
        key: 'handleKeyDown',
        value: function handleKeyDown(e) {
            var _this2 = this;

            e.persist();

            if (!this.handleCtryShortcut(e)) return false;

            if (this.inputTimeOutId) clearTimeout(this.inputTimeOutId);
            this.inputTimeOutId = setTimeout(function () {
                _this2.setState({
                    displayContent: (0, _marked2.default)(e.target.textContent, { renderer: _this2.markedRenderer })
                });
            }, 300);
        }
    }, {
        key: 'handleScroll',
        value: function handleScroll(e) {
            var _this3 = this;

            if (requestAnimationFrame) {
                requestAnimationFrame(function () {
                    var r = _this3.refs;
                    r.right.scrollTop = r.left.scrollTop * (r.right.scrollHeight - _this3.viewPortHeight) / (r.left.scrollHeight - _this3.viewPortHeight);
                });
            } else {
                var r = this.refs;
                r.right.scrollTop = r.left.scrollTop * (r.right.scrollHeight - this.viewPortHeight) / (r.left.scrollHeight - this.viewPortHeight);
            }
        }
    }, {
        key: 'handleSave',
        value: function handleSave(e) {
            var _this4 = this;

            setTimeout(function () {
                _this4.props.onSave(e.target.textContent);
            }, 0);
        }

        // handle ctrl+[key] shortcuts

    }, {
        key: 'handleCtryShortcut',
        value: function handleCtryShortcut(e) {
            var _this5 = this;

            var proxy = function proxy(func) {
                func();

                e.preventDefault();
                return false;
            };

            var keycode = String.fromCharCode(e.which || e.keyCode).toLowerCase();

            if ((e.which || e.keyCode) === 9) {
                // tab
                document.getSelection().getRangeAt(0).insertNode(new Text(' '.repeat(4)));
                this.collapseRange();
                e.preventDefault();

                // may cause some error
                return true;
            }

            if (!e.ctrlKey) return true;
            switch (keycode) {
                case 's':
                    return proxy(function () {
                        setTimeout(function () {
                            _this5.props.onSave(e.target.textContent);
                        }, 0);
                    });
                // case 'v':
                //     return proxy(() => {
                //         console.log('you call me?');
                //     });

                default:
                    return true;
            }
        }

        // when user click full button, call this method

    }, {
        key: 'fullScreen',
        value: function fullScreen(e) {
            if (this.state.leftClassName === 'left full') {
                e.target.textContent = '预览';
                this.setState({
                    leftClassName: 'left',
                    rightClassName: 'right',
                    printBtnDisplay: 'none',
                    saveBtnDisplay: 'block'
                });
            } else {
                this.setState({
                    leftClassName: 'left full',
                    rightClassName: 'right full',
                    printBtnDisplay: 'block',
                    saveBtnDisplay: 'none'
                });
                e.target.textContent = '编辑';
            }
        }

        // add print event to window.event

    }, {
        key: 'initPrint',
        value: function initPrint() {

            var self = this;

            if (window.matchMedia) {
                window.matchMedia('print').addListener(function (mql) {
                    if (mql.matches) {
                        self.beforePrint();
                    } else {
                        self.afterPrint();
                    }
                });
            } else {
                window.beforePrint = self.beforePrint();
                window.afterPrint = self.afterPrint();
            }
        }
    }, {
        key: 'beforePrint',
        value: function beforePrint() {
            if (this.props.onlyRead !== true) {

                // if set this by setState,
                // UI will delay
                this.refs.preview.style.display = 'none';
                this.refs.save.style.display = 'none';
                if (!this.refs.left.classList.contains('full')) {
                    this.refs.left.viewMode = false;
                    this.refs.left.classList.add('full');
                    this.refs.right.classList.add('full');
                } else {
                    this.refs.left.viewMode = true;
                }
            }
            this.refs.print.style.display = 'none';
        }
    }, {
        key: 'afterPrint',
        value: function afterPrint() {
            if (this.props.onlyRead !== true) {
                this.refs.preview.style.display = 'block';
                this.refs.save.style.display = 'block';

                if (!this.refs.left.viewMode) {
                    this.refs.left.classList.remove('full');
                    this.refs.right.classList.remove('full');
                }
            } else {
                this.refs.print.style.display = 'block';
            }
        }
    }, {
        key: 'print',
        value: function print(e) {
            window.print();
        }
    }, {
        key: 'collapseRange',
        value: function collapseRange() {
            // collapse range
            document.getSelection().collapse(document.getSelection().focusNode, document.getSelection().focusOffset);
        }
    }, {
        key: 'imgPaste',
        value: function imgPaste(e) {
            var _this6 = this;

            if (!e.clipboardData.items || !e.clipboardData.items[0]) return true;

            // get first clipboard data
            var data = e.clipboardData.items;
            if (data[0].kind === 'string' && data[0].type === 'text/plain') {
                e.preventDefault();

                data[0].getAsString(function (str) {
                    var matchObj = str.match(/^https?:\/\/.+\.(jpg|gif|png|jpeg|svg|bmp|apng)$/i);

                    // copy img flag
                    var text = matchObj ? '![](' + matchObj[0] + ')' : str;

                    // insert
                    var range = document.getSelection().getRangeAt(0);
                    range.deleteContents();
                    range.insertNode(new Text(text));
                    range.detach();
                    range = null;

                    // collapse range
                    _this6.collapseRange();
                });
            } else if ([0, 1].some(function (o) {
                return data[o].kind === 'file' && data[o].type.startsWith('image');
            })) {
                var target = e.target;

                var loadStr = '![uploading you pic...]()';
                var loadTextNode = new Text(loadStr);
                var range = document.getSelection().getRangeAt(0);

                // clear select
                range.deleteContents();

                range.insertNode(loadTextNode);
                this.collapseRange();

                var xhr = new XMLHttpRequest();
                xhr.open('post', '/api/uploadPic');
                xhr.onreadystatechange = function () {
                    if (xhr.readyState === 4 && xhr.status === 200) {

                        var imageUrl = '![](' + xhr.responseText + ')';
                        range.insertNode(new Text(imageUrl));

                        range.setStart(loadTextNode, 0);
                        range.setEnd(loadTextNode, loadStr.length);

                        range.deleteContents();
                        range.detach();
                        range = null;

                        _this6.collapseRange();

                        // render display content
                        _this6.setState({
                            displayContent: (0, _marked2.default)(target.textContent, { renderer: _this6.markedRenderer })
                        });
                    }
                };

                xhr.send((data[0].kind === 'file' ? data[0] : data[1]).getAsFile());
            }
        }

        // user click save button

    }, {
        key: 'save',
        value: function save(e) {
            var _this7 = this;

            var text = e.target.textContent;
            setTimeout(function () {
                _this7.props.onSave(text);
            }, 0);
        }
    }, {
        key: 'render',
        value: function render() {
            if (this.props.onlyRead === true) {
                return _react2.default.createElement(
                    'div',
                    { className: 'main' },
                    _react2.default.createElement(
                        'div',
                        {
                            ref: 'right',
                            className: this.state.rightClassName + ' full' },
                        _react2.default.createElement(
                            'div',
                            {
                                ref: 'print',
                                className: 'print onlyRead',
                                onClick: this.print.bind(this)
                            },
                            '\u6253\u5370'
                        ),
                        _react2.default.createElement('div', { dangerouslySetInnerHTML: { __html: this.state.displayContent } })
                    )
                );
            } else {
                return _react2.default.createElement(
                    'div',
                    { className: 'main' },
                    _react2.default.createElement(
                        'div',
                        {
                            ref: 'left',
                            className: this.state.leftClassName,
                            onKeyDown: this.handleKeyDown.bind(this),
                            onScroll: this.handleScroll.bind(this) },
                        _react2.default.createElement(
                            'div',
                            {
                                ref: 'save',
                                className: 'save',
                                style: { display: this.state.saveBtnDisplay },
                                onClick: this.save.bind(this)
                            },
                            '\u4FDD\u5B58'
                        ),
                        _react2.default.createElement(
                            'div',
                            {
                                ref: 'preview',
                                className: 'full-srceen',
                                onClick: this.fullScreen.bind(this)
                            },
                            '\u9884\u89C8'
                        ),
                        _react2.default.createElement(
                            'pre',
                            {
                                ref: 'textInput',
                                contentEditable: 'plaintext-only',
                                onPaste: this.imgPaste.bind(this)
                            },
                            this.props.text
                        )
                    ),
                    _react2.default.createElement(
                        'div',
                        {
                            ref: 'right',
                            className: this.state.rightClassName },
                        _react2.default.createElement(
                            'div',
                            {
                                ref: 'print',
                                className: 'print',
                                style: { display: this.state.printBtnDisplay },
                                onClick: this.print.bind(this)
                            },
                            '\u6253\u5370'
                        ),
                        _react2.default.createElement('div', { dangerouslySetInnerHTML: { __html: this.state.displayContent } })
                    )
                );
            }
        }
    }]);

    return MarkDown;
}(_react2.default.Component);

exports.default = MarkDown;